Subject: Re: [PATCH 2/2] clk: core: link consumer with clock driver

From: Miquel Raynal <[email-masked]>
Date: Mon, 3 Dec 2018 23:16:55 +0100

Hi Stephen,

Stephen Boyd <[email-masked]> wrote on Mon, 03 Dec 2018 11:20:31
-0800:

> Quoting Miquel Raynal (2018-11-30 02:20:52)
> > Hi Stephen,
> > 
> > Stephen Boyd <[email-masked]> wrote on Fri, 30 Nov 2018 01:26:20
> > -0800:
> >   
> > > Quoting Miquel Raynal (2018-11-23 01:11:32)  
> > > > Would you agree with me adding dummy functions in the #else section
> > > > like:
> > > > 
> > > > static inline void __clk_device_link(struct device *consumer, struct clk *clk)
> > > > {
> > > >        return;
> > > > }
> > > > 
> > > > static inline void __clk_device_unlink(struct clk *clk)
> > > > {
> > > >        return;
> > > > }
> > > > 
> > > > Do you want me to also declare these functions in the #if section
> > > > (with the external keyword) to balance the above declarations?    
> > > 
> > > Why can't we do the linking in __clk_get() and __clk_put()?
> > >   
> > 
> > Because we need the caller's 'struct device' to make the link and
> > this is not available in __clk_get(). I tried to ad it as parameter but
> > I don't think it is possible to retrieve a 'struct device' from the
> > device name. The functions where this is problematic are:
> > * clk.c:__of_clk_get_from_provider()
> > * clkdev.c:clk_get_sys()
> > 
> > By the way in my new version I called the helpers:
> > * clk_{link,unlink}_hierarchy()
> > * clk_{link,unlink}_consumer()
> > 
> > I will send a new version with these helpers, but if you have anything
> > in mind to help me achieve the above request, I will welcome the idea.
> >   
> 
> We can do the linking in __clk_get() and __clk_put() if we poke into the
> struct clk -> struct clk_core and bury the struct device into each
> clk_core structure.
> 

I meant the consumer device's structure. Yes, from a struct clk, the
first change in patch 1/2 let's us do clk->core->dev to get the clock
device. But for linking I need both the clock device and the consumer
device; and the latter will be missing in __clk_get().

Thanks,
Miquèl

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel